<?php
/*
 * $Id: carbon_edit.inc,v 1.3 2009/01/06 22:19:26 johnackers Exp $ 
 *  
 * Created on 19-Feb-2008
 *
 * 
 * 
 * Functions in this file create the consolidated account page
 */


function carbon_edit($uid)
{
  $r = carbon_stamp_array_load(null, $uid, null);

  $stamps = $r["stamp"];   
}



/**
 * Render a page listing a one line summary of all carbon footprints 
 */


function carbon_edit_page($uid) {
  global $user;
  
  $path = carbon_include_core_js();
  drupal_add_js($path . "/carbon_insitu_edit.js", "module"); 
  
  $header = array(
    array("data" => t("title"),   "field" => "title"),
    array("data" => t("start"),   "field" => "startdate"),
    array("data" => t("end"),     "field" => "enddate"),
    array("data" => t("code"),    "field" => "code"),
    array("data" => t("amount"),  "field" => "reading"),
    array("data" => t("fp's"),    "field" => "numfoot"),
    array("data" => t("status"),  "field" => "status"),
    array("data" => t("operations"))
  );
  
  if (empty($uid))
    $header[] = array("data" => t("author"),"field" => "name");

  $sql = "SELECT  t.*, n.title, n.nid, n.status, n.uid, n.type, name, count(*) as numfoot, " .
         "BIT_OR(POWER(2,a.protection)) as protect2, j.sid " .
         "FROM {carbon_stamp} t " .
         "INNER JOIN {node} n                   ON t.nid = n.nid " .
         "INNER JOIN {users} u                  ON n.uid = u.uid " .
         "LEFT  JOIN {carbon_stamp_account} j   ON t.nid = j.sid " .         
         "LEFT  JOIN {carbon_account} a         ON j.fid = a.nid " .
         ((empty($uid) ? '' : " where n.uid = ".$uid. " ") . 
         "GROUP BY t.nid "); 
  
//  $sql .= tablesort_sql($header); 
  
  // get the links (no range limit here)
  $queryResult = db_query($sql);

  $sampleRecord = null ;
  while ($node = db_fetch_object($queryResult)) 
  {
    $node->protection = _log2($node->protect2); 
    $ro_access = carbon_access("view", $node); 
    if ($ro_access)
    {
      $row =  array(carbon_link_from_title($node, $node),
        $node->startdate == 0 ? '' : _format_date($node->startdate, "small"),
        _format_date($node->enddate,"small"),
        $node->code, 
        $node->reading.' '._get_scope_key($node->scope),
        $node->numfoot <= 1 ? (isset($node->sid) ? 1 : 0) : $node->numfoot,     
        $node->status >= 1 ? 'pub' : '',
        $node->protection . " " . carbon_edit_ops($node, null));
    
      if (empty($uid))
        $row[] = $node->name ;
      $rows[] = $row ;   // "<DIV ID=". $node->nid . ">" . $row . "</DIV>";  
    }
    $sampleRecord = $node ;  
  }
  $output = "<form class='aj-submit-0'>" . theme("table", $header, $rows) . "</form>";
  $output .= theme("pager", NULL, 10, 0);

  $title = t("Carbon Meter");
   
  if (!empty($uid)) 
    $title .= t(" owned by !name", array("!name" => $sampleRecord->name));
     
  drupal_set_title(check_plain($title));      
  
  if (isset($sampleRecord))
  {
    $links = carbon_link("node", $sampleRecord); 
    $output .= theme_links($links);    // format links
  }  
  
  return carbon_add_debug_panel($output);

}

/**
 * Handle a GET reuquest to edit in situ a carbon stamp
 *
 * @param unknown_type $nid
 */


function carbon_edit_stamp($nid)
{        
  $form = array("#stamp-nid" => $nid); 

  $output = drupal_get_form("carbon_stamp_form2", $form); // neeed to wrap the table 
  
  $form["#action"] = "/carbon5/?q=carbon/meter/edit/960&amp;datatype=json&amp;datatype=json" ;
  $form["#id"] = "carbon-stamp-form2";
	
	// we want to use standard drupal form creation but you cannot use/add the 
	// form tag to an existing page (at least that's waht i found) so remove 
	// the form tags here. 
    	
	$output = ereg_replace('<form[^>]*>',"<div class='aj-submit'>", $output) ; // remove the form 
  $output = ereg_replace('</form[^>]*>',"</div>", $output) ; // remove the /form 

	
	// create a new instance of Services_JSON
  require_once(CARBON_PATH .'/json.php');
  $json = new Services_JSON();
 
  $output = $json->encode($output);
  print($output);
  exit(0);	
}


function carbon_edit_node($nid)
{
  $node = node_load($nid); // get this stamp
    
  $form = node_form($node);
  
  //todo form needs sorting out, no proper form id 
  $output = drupal_render_form("23444", $form);

  return $output ; 		
}



// don't think these functions should be here. 


function carbon_meter_table2($nid)
{

	$form = array(); 

	if (isset($nid))
    $form["#meter-nid"] = $nid; 	

  $output = drupal_get_form("carbon_meter_table_form", $form); // need to wrap the table 	

  // if the nid id specified then we are doing an update on a single 
  // line in the table using HTML transferred by JSON and injected
  // into the dom.  
  
  if (isset($nid))
  {
    $output = ereg_replace('<form[^>]*>',"", $output) ;  // remove the form 
    $output = ereg_replace('</form[^>]*>',"", $output) ; // remove the /form   	
    $output = ereg_replace('<div[^>]*>',"", $output) ;   // remove the div 
    $output = substr($output, 6, strlen($output)-6);
            
    // create a new instance of Services_JSON
	  require_once(CARBON_PATH .'/json.php');
	  $json = new Services_JSON();
	 
	  $output = $json->encode($output);
	  print($output);
	  exit(0); 
  }   
  return carbon_add_debug_panel($output);
}





function carbon_meter_table_form2($form)
{
  $nid = $form["#meter-nid"]; 	
  
  $model_map = _get_model_map($source);
  
  $source = carbon_source_fetch_array();  
    
  $source_map = _get_source_map($source);
  $source_keys = array_keys($source_map);     
  $source_descriptions = array_values($source_map);
    
  if (isset($nid))
  { 
    $node = node_load($nid); // get this stamp
    
    $form = _stamp_form2($form, $node, $source_keys, $source_descriptions);
  }
  else
  {
    $form["body"] = array(      
    "#type" => "item",     
    "#value" => carbon_meter_table_build2()); 	
  }
  return $form ; 
}


function carbon_meter_table_build2()
{
	$uid = 10; 
	
	carbon_include_js(); 
  
  $header = array(
    array("data" => t("title"),   "field" => "title"),
    array("data" => t("start"),   "field" => "startdate"),
    array("data" => t("end"),     "field" => "enddate"),
    array("data" => t("code"),    "field" => "code"),
    array("data" => t("amount"),  "field" => "reading"),
    array("data" => t("fp's"),    "field" => "numfoot"),
    array("data" => t("status"),  "field" => "status"),
    array("data" => t("operations"))
  );
  
  if (empty($uid))
    $header[] = array("data" => t("author"),"field" => "name");

  $sql = "SELECT  t.*, n.title, n.nid, n.status, n.uid, n.type, name, count(*) as numfoot, " .
         "BIT_OR(POWER(2,a.protection)) as protect2, j.sid " .
         "FROM {carbon_stamp} t " .
         "INNER JOIN {node} n                   ON t.nid = n.nid " .
         "INNER JOIN {users} u                  ON n.uid = u.uid " .
         "LEFT  JOIN {carbon_stamp_account} j   ON t.nid = j.sid " .         
         "LEFT  JOIN {carbon_account} a         ON j.fid = a.nid " .
         ((empty($uid) ? '' : " where n.uid = ".$uid. " ") . 
         "GROUP BY t.nid "); 
  
//  $sql .= tablesort_sql($header); 
  
  // get the links (no range limit here)
  $queryResult = db_query($sql);

  $sampleRecord = null ;
  while ($node = db_fetch_object($queryResult)) 
  {
    $node->protection = _log2($node->protect2); 
    $ro_access = carbon_access("view", $node); 
    if ($ro_access)
    {
      $row =  array(carbon_link_from_title($node, $node),
        $node->startdate == 0 ? '' : _format_date($node->startdate, "small"),
        _format_date($node->enddate,"small"),
        $node->code, 
        $node->reading.' '._get_scope_key($node->scope),
        $node->numfoot <= 1 ? (isset($node->sid) ? 1 : 0) : $node->numfoot,     
        $node->status >= 1 ? 'pub' : '',
        $node->protection . " " . carbon_edit_ops($node, null));
    
      if (empty($uid))
        $row[] = $node->name ;
      $rows[] = $row ;   // "<DIV ID=". $node->nid . ">" . $row . "</DIV>";  
    }
    $sampleRecord = $node ;  
  }
  $output = theme("table", $header, $rows);

  $title = t("Carbon Meter");
   
  if (!empty($uid)) 
    $title .= t(" owned by !name", array("!name" => $sampleRecord->name));
     
  drupal_set_title(check_plain($title));      
  
  if (isset($sampleRecord))
  {
    $links = carbon_link("node", $sampleRecord); 
    $output .= theme_links($links);    // format links
  }
  return $output ;   
}



function theme_carbon_meter_table_form2($form) 
{
  $selected_fields = array("title","startdate_s","enddate_s","code_index","reading","update");

  $output = "" ; // <td> jfiojrf hi there </td>";

  foreach ($selected_fields as $fieldname)
  {
    $field = $form[$fieldname]; 
    if (empty($field))
      continue ; 
 
    if ($field["#type"] == "hidden") // don't render hidden fields 
      continue ; 
      
    $output .= "<TD>" . drupal_render($field) . "</TD>";
  }
//  unset($form[$fieldname]);  // there is only one fieldset
//  $output .= drupal_render($form); // the whole form has been rendered
  return $output ;
}


function  carbon_meter_table_form_validate2($form, $p2)
{ 
	return 0 ; 
}


function  carbon_meter_table_form_submit2($form_id, $form)
{
 // $node->save();   
  return 0 ; 
}




function carbon_stamp_form2($form)
{  
  $nid = $form["#stamp-nid"]; 
  
	$model_map = _get_model_map($source);
  
  $source = carbon_source_fetch_array();  
    
  $source_map = _get_source_map($source);
  $source_keys = array_keys($source_map);     
  $source_descriptions = array_values($source_map);
    
  $node = node_load($nid); // get this stamp 
		
  $form = _stamp_form2($form, $node, $source_keys, $source_descriptions);
  $form['#attributes'] = array('class' => 'aj-submit-0');	

  return $form ; 
}



/**
 * Creat a a kind of super form with most of the regularaly used fields 
 * then disable the ones we don't want later. 
 *
 * @param unknown_type $subform
 * @param unknown_type $template
 * @param unknown_type $source_keys
 * @param unknown_type $source_descriptions
 * @return unknown
 */

 
function _stamp_form2(&$subform, $template, $source_keys, $source_descriptions)
{       
  $subform["title"] = array(      
    "#type" => "textfield",     
    "#size" => 14,
    "#readonly" => false,
    "#value" => $template->title, 
    "#maxlength" => 20 
    );             
       

  $subform["startdate_s"] = array(    
    "#type" => "textfield",     
    "#size" => 8,
    "#readonly" => true,
    "#value" => $template->startdate == 0 ? "" : _format_date($template->startdate, "custom", "Y-m-d H:i:s"),
    "#maxlength" => 20 
  );        
       
       
  $subform["enddate_s"] = array(
          
    "#type" => "textfield",     
    "#size" => 8,
    "#readonly" => true,
    "#value" => $template->enddate == 0 ? "" : _format_date($template->enddate, "custom", "Y-m-d H:i:s"),
    "#maxlength" => 20 
  );        
       
       
  $subform["choice"] = array(    
    "#type" => "radios", 
    "#options" => array("one","meter"), 
    "#default_value" => 1,   
 //   "#description" => t("Select type of carbon debit"),                
    "#attributes" => array("onchange" => "scope_change(this.value);")
  );       
             
  $subform["help"] = array(
        
    "#type" => "item",
    "#value" => $fields[0], 
    "#size" => 14,
    "#maxlength" => 20,         
    "#value" => "<div class='scope-1' style='white-space: normal'>" .
    t("Note that meter readings are subtracted from one another to calculate " .
    "consumption. You need to have at least two meter readings before this source of " .
    "emissions will be included in your carbon footprint.")."</div>",  
    );
 
  $subform["code_index"] = array(
    "#type" => "select", 
//    "#title" => t("select type of carbon debit"),  
    "#required" => FALSE, 
    "#options" => $source_descriptions,   
    "#value" => empty($template->code) ? 0 : array_search($template->code,$source_keys),
    "#size" => 1,
    "#maxlength" => 20, 
//    "#description" => "<div class='scope-0'>".t("Enter the one off value")."</div>". 
  //                    "<div class='scope-1'>".t("Enter the meter reading")."</div>",
    "#weight" => 0);
           
       
  $subform["reading"] = array(
       
    "#value" => 0,      
    "#type" => "textfield",     
    "#value" => $template->reading,
    "#size" => 8,
//        "#description" => "<div class='scope-0'>Enter the one off value</div>". 
  //                        "<div class='scope-1'>Enter the meter reading</div>", 
    "#maxlength" => 20,  
//        "#suffix" => "KWh of electricity"
    );
       
  $subform["adjust"] = array(
//  "#prefix" => "adjustment",     
    "#value" => 0,      
    "#type" => "textfield",     
    "#size" => 8,
//        "#description" => "<div class='scope-0'>Enter the one off value</div>". 
  //                        "<div class='scope-1'>Enter the meter reading</div>", 
    "#maxlength" => 20  
    );

  $subform["co2"] = array(
      
    "#type" => "textfield",     
    "#size" => 14,
    "#readonly" => true,
    "#maxlength" => 20 
  );
  $subform["toCo2"] = array(
      
    "#type" => "hidden",     
    "#value" => 1444
    );     

  $subform["update"] = array(
      
    "#type" => "submit",     
    "#value" => "update"
    );               
  return $subform ;   
} 
  






function theme_carbon_stamp_form2($form) 
{
  $selected_fields = array("title","startdate_s","enddate_s","code_index","reading","update");

  $output = "" ; // <td> jfiojrf hi there </td>";

  foreach ($selected_fields as $fieldname)
  {
  	$field = $form[$fieldname]; 
  	if (!isset($field))
      continue ; 
      
    if (substr($fieldname,0,1) == "#") // don't render irrelevant fields 
      continue ; 
 
    if ($field["#type"] == "hidden") // don't render hidden fields 
      continue ; 
      
    $output .= "<TD>" . drupal_render($field) . "</TD>";
  }
//  unset($form[$fieldname]);  // there is only one fieldset
//  $output .= drupal_render($form); // the whole form has been rendered
  return $output ;
}



function form_render($col)
{
  if (is_array($col)) return $col[0];
  return $col ;   
  
}


function carbon_edit_ops($node, $query)
{
	return carbon_highlighted_link2($node,"edit", "", "carbon/edit/".$node->nid, $query, "#080") ;
}


function carbon_highlighted_link2($node, $text, $title, $path, $query, $color)
{
  $access = carbon_access(is_object($node) ? "update":"create", $node);  // $node->type must be set! 
  if (!$access)
    return "" ; 

  $html = "<a title='".$title."' id=". $node->nid . " class='inSituEdit' href='".check_url(url($path, $query, null, false))."'><span style= 'font-size : -1; color: #FFF ; background-color: ".$color.";'>".$text."</span></a>"; 
  return $html ;
}


?>