<?php
/** 
 * $Id: carbon_meter.inc,v 1.2 2009/01/06 22:19:26 johnackers Exp $ 
 * 
 * Drupal carbon module.
 * 
 * A carbon_meter represents an utility meter.
 * 
 * Created on 11-Mar-2008
 *
 */



/**
 * Implementation of hook_access().
 * 
 * Refer to carbon_access because it is easier to check 
 * access for all carbon types in one place.  
 */


function carbon_meter($op, $node)
{
  return carbon_access($op, $node);
}


/**
 * Implementation of hook_form().
 *
 * @param unknown_type $node
 * @param unknown_type $param
 */
function carbon_meter_form(&$node, &$param) {
    
  $form["title"] = array(
    "#type" => "textfield", 
    "#title" => t("Meter description"), 
    "#required" => FALSE, 
    "#size" => 20,
    "#maxlength" => 80,       
    "#weight" => 2,
    "#default_value" => empty($node->title) ? "" : $node->title,   
    "#description" => t("Enter house name, utility e.g. gas or electricity or car name"));
  
  return $form ; 
}

/**
 * As there are no fields apart from the title, there is no need 
 * for any code to present the node
 */


function carbon_meter_table($mid, $uid) 
{
	global $carbon_table_body; 
  $carbon_table_body = carbon_meter_table_build();
//	$output = drupal_get_form("carbon_reading_form"); // need to wrap the table  
  $output = $carbon_table_body ; 
	return carbon_add_debug_panel($output);	
}


function carbon_meter_table_form($form)
{
  $form["body"] = array(      
    "#type" => "item",     
    "#value" => carbon_meter_table_build());   
  
  return $form ; 
}


function carbon_meter_table_build()
{
  carbon_include_js();  
  
  $header = array(
    array("data" => t("date"),   "field" => "date"),
    array("data" => t("reading"),"field" => "reading"),
    array("data" => t("note"),   "field" => "title"),
    array("data" => t("operations"))
  );
  
  if (empty($uid))
    $header[] = array("data" => t("author"),"field" => "name");

  $sql = "SELECT  r.*, n.title, n.nid, n.status, n.uid, n.type, m.title as meter_title " .
         "FROM {carbon_reading} r " .
         "INNER JOIN {node} n                   ON r.nid = n.nid " .
         "INNER JOIN {users} u                  ON n.uid = u.uid " .      
         "LEFT  JOIN {node} m                   ON m.nid = r.mid " .
 //        ((empty($uid) ? '' : " where n.uid = ".$uid. " ") .  broken
         ((empty($mid) ? '' : " where r.mid = ".$mid. " ") . 
         "GROUP BY r.mid "); 
  
//  $sql .= tablesort_sql($header); 
  
  // get the links (no range limit here)
  $queryResult = db_query($sql);

  $sampleRecord = null ;
  while ($node = db_fetch_object($queryResult)) 
  {
    $node->protection = 255 ; //_log2($node->protect2); 
    $ro_access = carbon_access("view", $node); 
    if ($ro_access)
    {
      $row =  array(
        _format_date($node->date,"small"),
        $node->reading,
        $node->title,
        $node->protection . " " . carbon_edit_ops($node, null));
    
      if (empty($mid))
        $row[] = "no data" ;
      $rows[] = $row ;   // "<DIV ID=". $node->nid . ">" . $row . "</DIV>";  
    }
    $sampleRecord = $node ;  
  }
  $output = "<form>" . theme("table", $header, $rows) . "</form>";
  $output .= theme("pager", NULL, 10, 0);

  $title = t("Meter");
   
  if (!empty($uid)) 
    $title .= t("!title", array("!title" => $sampleRecord->meter_title));
     
  drupal_set_title(check_plain($title));      
  
  if (isset($sampleRecord))
  {
    $links = carbon_link("node", $sampleRecord); 
    $output .= theme_links($links);    // format links
  }     
  return ($output);
}



?>