<?php
/** 
 * $Id: carbon_reading.inc,v 1.2 2009/01/06 22:19:26 johnackers Exp $ 
 * 
 * Drupal carbon_reading module.
 * 
 * A carbon_reading is an utility meter reading e.g. gas or electricity.
 * 
 * Created on 11-Mar-2008
 *
 */



/**
 * Implementation of hook_access().
 * 
 * Refer to carbon_access because it is easier to check 
 * access for all carbon types in one place.  
 */


function carbon_reading($op, $node)
{
  return carbon_access($op, $node);
}


/**
 * Implementation of hook_form().
 *
 * @param unknown_type $node
 * @param unknown_type $param
 */
function carbon_reading_form(&$node) 
{
  global $carbon_table_body ;
  if (isset($carbon_table_body))
  {
    $form["body"] = array(      
    "#type" => "item",     
    "#value" => $carbon_table_body); 
    return $form ;
  }
  $form["mid"] = array(
    "#type" => "textfield", 
    "#title" => t("Meter id"), 
    "#required" => TRUE, 
    "#size" => 8,
    "#maxlength" => 8,       
    "#weight" => 0,
    "#default_value" => $node->mid,   
    "#description" => t("Meter id"));
  
  $form["reading"] = array(
    "#type" => "textfield", 
    "#title" => t("Meter reading"), 
    "#required" => TRUE, 
    "#size" => 8,
    "#maxlength" => 8,       
    "#weight" => 0,
    "#default_value" => $node->reading,   
    "#description" => t("Only whole units need to be entered"));

  $form["date_s"] = array(
    "#type" => "textfield", 
    "#title" => t("Reading date"), 
    "#required" => TRUE, 
    "#size" => 20,
    "#maxlength" => 20,       
    "#weight" => 1,
    "#default_value" => empty($node->date)  ? "" : _format_date($node->date, "custom", "Y-m-d H:i:s"),
    "#description" => t("Date that meter reading was taken"));  
    
  $form["title"] = array(
    "#type" => "textfield", 
    "#title" => t("Note"), 
    "#required" => FALSE, 
    "#size" => 20,
    "#maxlength" => 80,       
    "#weight" => 2,
    "#default_value" => empty($node->title) ? "" : $node->title,   
    "#description" => t("Not normally used or required"));
  

  $form["upate"] = array(
    "#type" => "submit", 
    "#value" => t("update2")); 
  
  
  return $form ; 
}


function carbon_reading_form_submit($form_id, &$form)
{
	$id = 33 ; 
	// Do node-type-specific validation checks.
//  node_invoke($node, 'submit');
  //  node_invoke_nodeapi($node, 'submit');

//  $node->validated = TRUE;		

}


/**
 * Implemenation of hook_load 
 * @param node object to load additional information for
 * @return object with carbon fields 
 */
function carbon_reading_load($node)  {
    
  $record = db_fetch_object(db_query("SELECT * " .
      "FROM {carbon_reading} WHERE nid = %d ", $node->nid));
  return $record;
}


/**
 * Implementation of hook_insert
 * 
 * @param node object
 */
function carbon_reading_insert(&$node) {

  db_query("INSERT INTO {carbon_reading} " .
        "(nid, mid, date, reading) " .
        "VALUES (%d, %d, %d, %d)", 
  $node->nid, $node->mid, $node->date, $node->reading);
}


/**
 * Implementation of hook_update
 * 
 * @param node object
 */
function carbon_reading_update(&$node) {
  
  db_query("UPDATE {carbon_reading} set mid=%d, date=%d, reading=%d WHERE nid=%d", 
  $node->mid, $node->date, $node->reading, $node->nid);
}


/**
 * Implementation of hook_delete().
 */
function carbon_reading_delete($node) {
  db_query("DELETE FROM {carbon_source} WHERE nid = %d", $node->nid);
}


/**
 * Implementation of hook_view, add our node specific information
 * @param node object to display
 * @param boolean is this a teaser or full node?
 * @param boolean is this displaying on its own page
 */

function carbon_reading_view(&$node, $teaser = FALSE, $page = FALSE) 
{
  $node = node_prepare($node, $teaser);
  $carbon_reading_info = theme('carbon_reading_view', $node);  // try item_list
  $node->content["carbon_reading"] = array("#value" => $carbon_reading_info);   
  $node->body .= "gjhg";
  $node->teaser .= "hkjhk";
  return $node ;
}


function theme_carbon_reading_view($node)
{
	$output = "Meter id: " . $node->mid . " date: " . $node->date . " reading: " .  $node->reading  ;
  return $output ; 
}


function theme_carbon_reading_node_form(&$form) 
{
  global $datatype;
	$json = strpos($form["#action"], "datatype=json"); 
	
  if (!$json) 
  {
  	return null ; // hopefully fallback to standard rendering 
  }
  else
    $datatype="json"; 
  
  $form["update"] = array(
      
    "#type" => "submit",     
    "#value" => "update"
    );
      
  $selected_fields = array("date_s","mid","reading","update");

  $output = "" ; // <td> jfiojrf hi there </td>";


  foreach ($selected_fields as $fieldname)
  {
    $field = $form[$fieldname]; 
    if (empty($field))
      continue ; 
 
    if ($field["#type"] == "hidden") // don't render hidden fields 
      continue ; 
      
    unset($field['#title']);  
    unset($field['#description']);  
    $output .= "<TD>" . drupal_render($field) . "</TD>";
  }
  $output = "<DIV CLASS='inSituEdit'>" . $output . "</DIV>" ;

//	$output = drupal_render($form);	
//  $output = ereg_replace('<form[^>]*>',"", $output) ;  // remove the form 
//  $output = ereg_replace('</form[^>]*>',"", $output) ; // remove the /form    
//  $output = ereg_replace('<div[^>]*>',"", $output) ;   // remove the div 
//  $output = substr($output, 6, strlen($output)-6);
            
  return $output ;
}

function carbon_alter_theme_page() {
  global $theme;
  
  // Because theme() is called a lot, calling init_theme() only to have it
  // smartly return is a noticeable performance hit. Don't do it.
  if (!isset($theme)) {
    init_theme();
  }

  if ($theme != '') 
  {
    if (function_exists($theme .'_page')) 
    {
      break ; 
    }
    return $theme = "carbon" ; 
  }
}



/**
 * Check to see whether we need to generate JSON output 
 * format in response to ajax requests. 
 * This seems to be the only way to do this in Drupal.  
 */

function encode_datatype() 
{
  global $return ; 
	if ($_GET["datatype"] == "json")
  {
    require_once(CARBON_PATH .'/json.php');  	
    // create a new instance of Services_JSON
  	$json = new Services_JSON();   
    $output = $json->encode($return);
    print($output);
    exit(0);
  }  
}
?>