<?php
/*
 * $Id: carbon_view.inc,v 1.4 2009/01/06 22:19:26 johnackers Exp $ 
 *  
 * Created on 19-Feb-2008
 *
 * Web 2.0 functions  
 * 
 * Functions in this file create the consolidated account page
 * 
 * STILL IN DEVELOPMENT
 */

function carbon_view_consolidated($aid)
{
  $path = carbon_include_core_js();
  drupal_add_js($path . "/carbon_view.js", "module");
  	
  $output = "" ; 
  
  $output .= buildPeriodPanels($aid);
  
  $output .= carbon_add_panel("a load of transfers (account id wrong)", "/carbon5/?q=carbon/transfer/425");

  $output .= carbon_add_panel("Group sector report", 
    "/carbon5/?q=carbon/account&report=sector&firstdate=20061201&period=6&org=icrag");


/*  
  $sector_report = l("Sector report Dec 1st 2006 to Jun 1st 2007",
                   "", 
                   array("CLASS"=>"loadOnDemand", "ID"=>nextPanel()),
                   "q=carbon/account&report=sector&firstdate=20061201&period=6&org=icrag");
*/
  $output .= carbon_wrapFieldset("ICRAG", "my tip", $sector_report); 

  $output .= carbon_wrapFieldset("Carbon Purchases", 
                                 "my tip",
                                 l("All purchases made",
                                   "", 
                                   array("CLASS"=>"loadOnDemand", "ID"=>nextPanel()),
                                   "q=carbon/transfer/" . $account_id)); 
                                   
  $output = carbon_add_debug_panel($output);
                                     
  return $output  ; 
  
//	return $buttons. $switch . '<div id="carbon-1">loading data...</div>' ; 
	
}



/**
 * Add a link for every accounting period for which there is carbon data
 * @param $aid
 * @return unknown_type
 */
function buildPeriodPanels($aid) 
{
  $account = node_load($aid);  

	if (count($account->stamp) == 0)
    return carbon_calculate_empty_table($account);  
    
  $header = carbon_stamp_header();

  // move the stamps retrieved for this footprint into an array 

  $stamps = array();
  
  foreach ($account->stamp as $stamp)    // add the stamps
  {        
    $stamps[] = $stamp;
  }

  // find out the range of dates that we are dealing with
  
  $dateRange = _stamp_date_range($stamps);

 // work out where to place the boundary between years
 // use months and days from any user preference 
 // otherwise use Jan 1 in year of first stamp
  
  if (!empty($account->firstdate))       
  {  
    $y = _format_date($dateRange['first'], 'custom', 'Y') - 1 ;
    $m = _format_date($account->firstdate, 'custom', 'm');
    $d = _format_date($account->firstdate, 'custom', 'd'); 
  }
  else
  {
    $y = _format_date($dateRange['first'],  'custom', 'Y');
    $m = 0 ; 
    $d = 0 ;      
  }
  $earliestDate = mktime(0, 0, 0, $m, $d, $y);   

  // the purpose of the for loop is only to prevent 
  // any software bug from printing numerous reports
  
  $annual_report = "" ; 
  
  for ($i = 0 ; $i < 10 ; $i++)
  {
  	$firstdayinyear = _add_months($earliestDate, $i * $account->period);
    $firstdayinnextyear = _add_months($earliestDate, ($i + 1) * $account->period);

    // break out when last date reached                        
    if ($firstdayinyear> $dateRange['last']) 
      break ;     
    
    $firstdate_s = CarbonDate::asYYYYMMDD($firstdayinyear);  
   

    $annual_report .= _format_date_range($firstdayinyear, $firstdayinnextyear)."&nbsp"
                     .l("view",
                     "", 
                     array("CLASS"=>"loadOnDemand", "ID"=>nextPanel()),
                     $q = sprintf("q=carbon/account/%d&firstdate=%s&period=%d",
                     $aid, $firstdate_s, $account->period)) . "<br/>";
/*                  
    $annual_report .= l(_format_date_range($firstdayinyear, $firstdayinnextyear),
                     "", 
                     array("CLASS"=>"loadOnDemand", "ID"=>nextPanel()),
                     $q = sprintf("q=carbon/account/%d&firstdate=%s&period=%d",
                     $aid, $firstdate_s, $account->period)) . "<br/>" ;     
 */
  }   
  $output .= carbon_wrapFieldset(
  "Carbon statements for ".$account->title, "my tool tip", $annual_report); 
  return $output ; 
}


/**
 * Process a GET command to present a carbon footprint for a particular period. 
 * Handle requests for datatype json. 
 */

function carbon_view_year($aid)
{
  global $charts ; //$charts = array(t("none"), t("bar"), t("pie"));

  $params = _gather(array("firstdate"=>"20070101", "period"=>12, "datatype"=>""));
 
  $json = ($params["datatype"] == "json"); 
  
  $firstdayinyear = CarbonDate::fromYYYYMMDD($params["firstdate"]);
  
  $firstdayinnextyear = _add_months($firstdayinyear, $params["period"]);

  $ar = carbon_stamp_array_load($aid, null, null);   
  
	$results = carbon_calculate_total($aid, $ar["stamp"], $firstdayinyear, $firstdayinnextyear);         
          
  // if we are writing a chart, get the start date 
  // calculate the footprint and display the results

  // does not work.!!!
    
  if (carbon_chart_requested())
  {    
    $dataset = array(); 
    $dataset["account name"] = array(
      "data" => $results->sector_co2,
      "comment" => _format_date_range($firstdayinyear, $firstdayinnextyear)) ; 
    carbon_chart_generate($dataset, "CO2 emissions");
    return ;
  }  
   
  // if you request json format, the function below may not return   
  
  $output .= carbon_calculate_present_results($results);     

    // and embed the graphics
  if ($results->grand_co2 > 0)  // used to supply a date here
    $output .= carbon_chart_embed(variable_get("carbon_default_chart", null), 
                                  _format_date($firstdayinyear, "custom", "Ymd"));  
  
  if ($json)
  {
     // create a new instance of Services_JSON
    require_once(CARBON_PATH .'/json.php');
    $json = new Services_JSON();

 
    $output = $json->encode($output);
    print($output);
    exit(0);
  }  
  return $output  ; 
}


/**
 * allocate unique name to each panel on the page.  
 *
 * @return panelName 
 */

function nextPanel()
{
	global $panel ;
  $panel = isSet($panel) ? $panel+1 : 0 ;   
  return "panel-" . $panel ;  // allocate a unique name to each panel  
}

/**
 * wrap item in a fieldset (so it looks nice)
 *
 * @param string $title
 * @param string $tip
 * @param string $item
 * @return unknown
 */

function carbon_wrapFieldset($title, $tip, $item)
{
  return '<FIELDSET>'.
         ' <LEGEND TITLE="' . $tip . '">' . $title . '</LEGEND>'.
         $item. 
         '</FIELDSET>' ; 
}



function carbon_add_panel($title, $url)
{
  global $panel ;
  $panel = isSet($panel) ? $panel+1 : 0 ;   
  $panelName = "panel-" . $panel ;  // allocate a unique name to each panel
    
  $output = 
  '<FIELDSET>'.
  '  <LEGEND TITLE="tool tip here">Legend goes here</LEGEND>'.
  '  <A CLASS="loadOnDemand" ID="' . $panelName . '" HREF="' . $url .'">' . $title . '</A>'.
  '</FIELDSET>' ; 
  
  return $output ; 
}



function carbon_include_core_js()
{
  // load the common javascript routines
  
  $path = drupal_get_path("module", "carbon");
  drupal_add_js($path . "/carbon_debug.js", "module"); 
  drupal_add_js($path . "/jquery.form.js", "module");  
  drupal_add_css($path. "/carbon.css"); 

  drupal_add_js('misc/collapse.js', 'core', 'header', FALSE, TRUE);
  
  return $path ; 
}


function carbon_add_debug_panel($output)
{
  return $output . '<DIV ID="debugPanel">debug log:</DIV>' ;
}


class CarbonDate 
{
	function fromYYYYMMDD($s) // static removed
	{
    return mktime(0, 0, 0, substr($s,4,2), substr($s,6,2), substr($s,0,4));		
	}

  function asYYYYMMDD($time) // static removed
  {
    $y = _format_date($time, 'custom', 'Y');
    $m = _format_date($time, 'custom', 'm');
    $d = _format_date($time, 'custom', 'd');
    return sprintf("%04d%02d%02d", $y, $m, $d);   
  }
}


?>